"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Cypher = void 0;

var _driver = require("./driver");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var database = (0, _driver.getConnection)();
var OPERATORS = ['=', '=~', '<>', '<', '>', '<=', '>=', 'IS NULL', 'IS NOT NULL', 'STARTS WITH', 'ENDS WITH', 'CONTAINS', 'EXISTS', 'IN'];

var Cypher = /*#__PURE__*/function () {
  function Cypher() {
    var stmt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    _classCallCheck(this, Cypher);

    this.clean(stmt);
  }

  _createClass(Cypher, [{
    key: "clean",
    value: function clean() {
      var stmt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      this.nodes = [];
      this.matchs = [];
      this.wheres = [];
      this.sets = [];
      this.setString = '';
      this.orders = [];
      this["return"] = {};
      this.returnStrings = [];
      this.parameters = [];
      this.distinct = '';
      this.skip = '';
      this.limit = '';
      this.stmt = stmt;
    }
  }, {
    key: "addReturn",
    value: function addReturn(key, value) {
      this["return"][key] = value;
    }
  }, {
    key: "match",
    value: function match(node) {
      var _this = this;

      var previousAlias = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var relationship = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var targetModel = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var dontPutOnReturn = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

      if (targetModel) {
        var relationName = "".concat(node.getAliasName(), "_").concat(previousAlias).concat(relationship);
        var filterRelationship = '';

        if (targetModel.filter_relationship) {
          filterRelationship = '{' + Object.entries(targetModel.filter_relationship).map(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
                key = _ref2[0],
                value = _ref2[1];

            return "".concat(key, ":").concat(_this.addParameter(value));
          }).join(', ') + '}';
        }

        this.matchs.push("".concat(targetModel.isOptional ? 'OPTIONAL' : '', " MATCH (").concat(node.getAliasName(), ")-[").concat(relationName, " ").concat(filterRelationship, "]-(").concat(targetModel.getCypherName(previousAlias), ")"));
      } else {
        if (!dontPutOnReturn) {
          this.matchs.push("MATCH (".concat(node.getCypherName(), ")"));
        } else {
          this.matchs.push("MATCH (".concat(dontPutOnReturn, ":").concat(node.getNodeName(), ")"));
        }
      }
    }
  }, {
    key: "addSet",
    value: function addSet(attr, value) {
      switch (true) {
        case value instanceof Date:
          this.sets.push("".concat(attr, " = ").concat(this.addParameter(value.toISOString())));
          break;

        case typeof value === "undefined":
          //IGNORE
          break;

        default:
          this.sets.push("".concat(attr, " = ").concat(this.addParameter(value)));
      }
    }
  }, {
    key: "writeSets",
    value: function writeSets() {
      var CONCAT = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ' AND ';

      if (this.sets.length > 0) {
        this.setString = "SET ".concat(this.sets.join(CONCAT));
      }
    }
  }, {
    key: "parseWhereToString",
    value: function parseWhereToString(_ref3) {
      var _this2 = this;

      var attr = _ref3.attr,
          operator = _ref3.operator,
          value = _ref3.value,
          _ref3$not = _ref3.not,
          not = _ref3$not === void 0 ? false : _ref3$not,
          _ref3$$and = _ref3.$and,
          $and = _ref3$$and === void 0 ? [] : _ref3$$and,
          _ref3$$or = _ref3.$or,
          $or = _ref3$$or === void 0 ? [] : _ref3$$or;
      if ($and.length) return "(".concat($and.map(function (filter) {
        return _this2.parseWhereToString(filter);
      }).join(' AND '), ")");
      if ($or.length) return "(".concat($or.map(function (filter) {
        return _this2.parseWhereToString(filter);
      }).join(' OR '), ")");
      if (!OPERATORS.includes(operator)) operator = '=';
      if (value === undefined) return 'true';

      if (operator === 'IN' && !Array.isArray(value)) {
        throw new Error('on IN operator, value must be an Array');
      }

      return "".concat(not ? 'NOT' : '', " ").concat(attr, " ").concat(operator, " ").concat(this.addParameter(value));
    }
  }, {
    key: "addParameter",
    value: function addParameter(value) {
      var parameterName = "$param".concat(this.parameters.length + 1);
      this.parameters.push(value);
      return parameterName;
    }
  }, {
    key: "addWhere",
    value: function addWhere(_ref4) {
      var attr = _ref4.attr,
          operator = _ref4.operator,
          value = _ref4.value,
          $and = _ref4.$and,
          $or = _ref4.$or,
          _ref4$not = _ref4.not,
          not = _ref4$not === void 0 ? false : _ref4$not;
      this.wheres.push(this.parseWhereToString({
        attr: attr,
        operator: operator,
        value: value,
        $and: $and,
        $or: $or,
        not: not
      }));
    }
  }, {
    key: "writeWhere",
    value: function writeWhere() {
      if (this.wheres.length > 0) {
        var whereString = " WHERE ".concat(this.wheres.join(' AND '));
        this.wheres = [];
        return whereString;
      }

      return '';
    }
  }, {
    key: "addOrderBy",
    value: function addOrderBy(attr) {
      var direction = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'ASC';
      this.orders.push("".concat(attr, " ").concat(direction));
    }
  }, {
    key: "writeOrderBy",
    value: function writeOrderBy() {
      var CONCAT = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ' , ';

      if (this.orders.length > 0) {
        var orderString = " ORDER BY ".concat(this.orders.join(CONCAT));
        this.orders = [];
        return orderString;
      }

      return '';
    }
  }, {
    key: "isDistinct",
    value: function isDistinct() {
      var bool = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      this.distinct = bool ? 'DISTINCT' : '';
    }
  }, {
    key: "modelReturnRelation",
    value: function modelReturnRelation(alias, field) {
      var relationString = "".concat(alias, " {");
      var relAttrs = [];

      for (var _i2 = 0, _Object$entries = Object.entries(field.attributes); _i2 < _Object$entries.length; _i2++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i2], 1),
            relAttr = _Object$entries$_i[0];

        relAttrs.push(".".concat(relAttr));
      }

      relationString += "".concat(relAttrs.join(', '), " }");
      this.returnStrings.push(relationString);
    }
  }, {
    key: "modelReturn",
    value: function modelReturn(alias, model) {
      var returnString = model.collectFirst ? "collect(".concat(alias, " {") : "".concat(alias, " {");
      var attrs = [];
      attrs.push("id:id(".concat(alias, ")")); // LOOP ON MODEL ATTRIBUTES

      for (var _i3 = 0, _Object$entries2 = Object.entries(model._attributes); _i3 < _Object$entries2.length; _i3++) {
        var _Object$entries2$_i = _slicedToArray(_Object$entries2[_i3], 2),
            attr = _Object$entries2$_i[0],
            field = _Object$entries2$_i[1];

        if (!field.isModel) {
          attrs.push(".".concat(attr));
        }
      }

      returnString += attrs.join(', ');
      returnString += model.collectFirst ? " })[0] as ".concat(alias) : " }";
      this.returnStrings.push(returnString);
    }
  }, {
    key: "create",
    value: function create(nodeAlias) {
      var _this3 = this;

      this.writeSets(' , ');
      var stmt = "CREATE (".concat(nodeAlias, ") ").concat(this.setString, " RETURN ").concat(this.returnStrings.join(' , '));
      return new SessionPromise(stmt, function (acc) {
        return _this3.session(stmt, 'write').then(function (records) {
          return acc(records[0]);
        });
      });
    }
  }, {
    key: "update",
    value: function update() {
      this.writeWhere();
      this.writeSets(' , ');
      var stmt = "\n    ".concat(this.matchs.join(' '), "\n    ").concat(this.setString, "\n    RETURN ").concat(this.returnStrings.join(' , '));
      return this.session(stmt, 'write');
    }
  }, {
    key: "delete",
    value: function _delete(alias) {
      var _this4 = this;

      var detach = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var stmt = "".concat(this.matchs.join(' '), " ").concat(detach ? 'DETACH' : '', " DELETE ").concat(alias);
      return new SessionPromise(stmt, function (acc) {
        return _this4.session(stmt, 'write').then(function () {
          return acc(true);
        });
      });
    }
  }, {
    key: "relate",
    value: function () {
      var _relate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(node1, relation, node2) {
        var create,
            stmt,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                create = _args.length > 3 && _args[3] !== undefined ? _args[3] : true;
                this.writeWhere();
                this.writeSets(' , ');
                stmt = "".concat(this.matchs.join(' '), "\n                  ").concat(create ? 'CREATE' : 'MATCH', "\n                  (").concat(node1.getAliasName(), ")-[").concat(node1.getAliasName(), "_").concat(relation.attr, ":").concat(relation.getLabelName(), "]\n                  ").concat(create ? '->' : '-', "(").concat(relation.attr, ")\n                  ").concat(this.setString, " RETURN ").concat(this.returnStrings.join(' , '));
                return _context.abrupt("return", this.session(stmt, 'write'));

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function relate(_x, _x2, _x3) {
        return _relate.apply(this, arguments);
      }

      return relate;
    }()
  }, {
    key: "find",
    value: function find() {
      var stmt = "".concat(this.matchs.join(' '), " ").concat(this.setString, "\n                  RETURN ").concat(this.count ? "COUNT(".concat(this.count, ")") : "".concat(this.distinct, " ").concat(this.returnStrings.join(' , '), "\n                  ").concat(this.writeOrderBy(), " ").concat(this.skip ? "SKIP ".concat(this.skip) : '', " ").concat(this.limit ? "LIMIT ".concat(this.limit) : ''));
      return this.session(stmt);
    }
  }, {
    key: "session",
    value: function session(stmt) {
      var _this5 = this;

      var mode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'read';
      return new SessionPromise(stmt, function (resolve, reject) {
        var session = database.session({
          defaultAccessMode: mode === 'read' ? (0, _driver.getInstance)().session.READ : (0, _driver.getInstance)().session.WRITE
        });

        var params = _this5.parameters.reduce(function (acc, value, index) {
          return _objectSpread({}, acc, _defineProperty({}, "param".concat(index + 1), value));
        }, {});

        session.run(stmt, params).then(function (result) {
          return resolve(result.records);
        })["catch"](function (e) {
          return reject("Cypher ERROR: ".concat(e.message));
        }).then(function () {
          _this5.clean();

          session.close();
        });
      });
    }
  }]);

  return Cypher;
}();

exports.Cypher = Cypher;

var SessionPromise = /*#__PURE__*/function () {
  function SessionPromise(stmt, executor) {
    _classCallCheck(this, SessionPromise);

    this.executor = executor;
    this.stmt = stmt;
  }

  _createClass(SessionPromise, [{
    key: "toString",
    value: function toString() {
      return this.stmt;
    }
  }, {
    key: "then",
    value: function then() {
      var _Promise;

      return (_Promise = new Promise(this.executor)).then.apply(_Promise, arguments);
    }
  }, {
    key: "catch",
    value: function _catch() {
      var _Promise2;

      return (_Promise2 = new Promise(this.executor))["catch"].apply(_Promise2, arguments);
    }
  }]);

  return SessionPromise;
}();